package com.xynet.marketing.controller.member;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xynet.marketing.service.MemberCouponService;
import com.xynet.marketing.service.MercCouponService;
import com.xynet.marketing.utils.MemberAuthUtils;
import com.xynet.marketing.utils.R;
import com.xynet.marketing.utils.collections.map.JHashMap;
import com.xynet.marketing.utils.collections.map.JMap;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * 会员端优惠券控制器
 *
 * @author hechunping
 * @date 2025/2/17
 */
@RestController
@RequestMapping("member/coupon")
@AllArgsConstructor
@Slf4j
@CrossOrigin(origins = "*")
public class MemberCouponController {
    private MercCouponService mercCouponService;
    private MemberCouponService memberCouponService;

    @PostMapping("page")
    public R page(@RequestBody Map<String, Object> param, @RequestHeader Map<String, String> headers) {
        String memberId = MemberAuthUtils.getMemberId(headers);
        JMap<String, Object> jParam = new JHashMap<>(param);
        Page<Map<String, Object>> data = memberCouponService.page(jParam);
        return R.ok(memberId);
    }


    @PostMapping("saveOrUpdate")
    private R saveOrUpdate(@RequestBody Map<String, Object> param, @RequestHeader Map<String, String> headers) {
        JMap<String, Object> jParam = new JHashMap<>(param);
        return R.ok(memberCouponService.saveOrUpdate(jParam));
    }
}
